/*
 *	CERCA.C
 *	LaMoSca (LAboratorio di MOtori per SCAcchi)
 *	versione 0.08
 *	2001 Pietro Valocchi
 */


#include <stdio.h>
#include "Common.h"
#include "Extern.h"


/* AlphaBeta() esegue la ricerca della mossa ottima */
BOOL AlphaBeta(Mossa *M, int *ValorePosizione, int Alpha, int Beta) {

	int i, ValoreCorrente;
	BOOL Trovata = FALSE;

	/* genera mosse */
	GeneraPseudo();

	/* verifica che il re non sia in una casa destinazione */
	for (i = InizioMosse[Livello-1]; i < InizioMosse[Livello]; i++) {
		if (B[StackMosse[i].A].Pezzo == RE) {
			/* la mossa del livello precedente ha lasciato il re in scacco */
			return FALSE;
		}
	}

	/* valuta la posizione se siamo al livello massimo */
	if (Livello == (LivelloMassimo + 1)) {
		*ValorePosizione = Valuta();
		return TRUE;
	} else {

		/* prova tutte le mosse fino a trovare la migliore */
		if (LogFile) fprintf(LogFile, "\nL=%d, A=%d, B=%d: ", Livello, Alpha, Beta);

		*ValorePosizione = Alpha;
		ValoreCorrente = - INFINITO;
		for (i = InizioMosse[Livello-1]; ((i < InizioMosse[Livello]) && (ValoreCorrente < Beta)); i++) {

			/* esegui la mossa */
			Muovi(&StackMosse[i]);

			/* trova la risposta migliore per l'avversario */
			if (AlphaBeta(M, &ValoreCorrente, -Beta, -Alpha)) {
				Trovata = TRUE;

				/* massimizza il valore della posizione del programma */
				ValoreCorrente = - ValoreCorrente;
				if (ValoreCorrente > Alpha) {
					if (ValoreCorrente >= Beta) {
						/* cut */
						*ValorePosizione = Beta;
					} else {
						Alpha = ValoreCorrente;
						*ValorePosizione = Alpha;
						/* salva la mossa scelta se siamo alla root */
						if (Livello == 2) {
							M->A  = StackMosse[i].A;
							M->Da = StackMosse[i].Da;
						}
					}
				}
			}
			/* ripristina la mossa */
			TornaIndietro(&StackMosse[i]);

			if (LogFile) {
				fprintf(LogFile, "L%d%c%d%c%d=%d ", Livello, 
				COLONNA(StackMosse[i].Da)+ 'a', 8 - RIGA(StackMosse[i].Da), 
				COLONNA(StackMosse[i].A) + 'a', 8 - RIGA(StackMosse[i].A),
				ValoreCorrente);
				if (ValoreCorrente >= Beta) {
					fprintf(LogFile, "//Cut");
				}
			}
		}


		if (LogFile) {
			fprintf(LogFile, "\nRisultato L%d: T=%d", Livello, Trovata);
			if (Trovata == TRUE) {
				if (Livello == 1) {
					fprintf(LogFile, ", M=%c%d%c%d",
						COLONNA(M->Da)+ 'a', 8 - RIGA(M->Da), 
						COLONNA(M->A) + 'a', 8 - RIGA(M->A));
				}
				fprintf(LogFile, ", A=%d, B=%d", Alpha, Beta);
			}
			fprintf(LogFile, "\n");
		}
	}

	return Trovata;
}


